/**
 * 
 */
/**
 * @author dasheng
 *
 */
package com.baofoo.Demo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

import net.sf.json.JSONObject;

public class T100102401{
	/**
	 * 商户下单接⼝
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		String orderAmt="1000";
			
		
		String memberId = "100029078";
		String terminalId = "200004282";	
		String  pfxpath = "D:/CER_EN_DECODE/AgreementPay/TestAgr/bfkey_100029078@@200004282.pfx";//商户私钥        
        String  cerpath = "D:/CER_EN_DECODE/AgreementPay/TestAgr/bfkey_100029078@@200004282.cer";//宝付公钥        
        String  pfx_pwd = "123456";
		
        String ServerUrl = "https://vgw.baofoo.com/union-gw/api/T-1001-024-01/transReq.do";
        
		Map<String, String> HeaderPost = new HashMap<String, String>();
		HeaderPost.put("memberId", memberId);// 宝付提供给商户的唯一编号
		HeaderPost.put("terminalId",terminalId);
		HeaderPost.put("serviceTp", "T-1001-024-01");//
		HeaderPost.put("verifyType", "1");// 加密方式目前只有1种，请填：1
		
		String Trans_Id="TID" + FormatUtil.CreateAeskey(25);
		Log.Write("商户订单号："+Trans_Id);
		String tradeDate=new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());        		
		Map<String, String> BodyData = new TreeMap<String, String>();		
		BodyData.put("memberTransId",Trans_Id);// 商户订单号
		BodyData.put("memberId", memberId);//商户号
		BodyData.put("terminalId", terminalId);//终端号
		BodyData.put("tradeDate", tradeDate);//交易日期 格式：yyyyMMddHHmms
		BodyData.put("orderAmt", orderAmt);//单位：分
		BodyData.put("notifyUrl", "http://10.0.60.66:8080/MBNotifyWeb/ReturnUrl.action");//交易异步通知地址。
		
		
		BodyData.put("reqAddtion", "请求附加信息");//请求附加信息
		BodyData.put("tradeCode", "0");//0⼿机银⾏	1⼿机银
		BodyData.put("shareInfo", "");//分账信息
		BodyData.put("shareNotifyUrl", "");//分账通知地址
		
		Map<String, Object> contentData = new TreeMap<String, Object>();
		contentData.put("header", HeaderPost);		
		contentData.put("body", BodyData);
		
		
		
		JSONObject jsonObjectFromMap = JSONObject.fromObject(contentData);
		String Jsonstr = jsonObjectFromMap.toString();
		Log.Write("序列化：" + Jsonstr);

		String base64str = SecurityUtil.Base64Encode(Jsonstr);
		String data_content = RsaCodingUtil.encryptByPriPfxFile(base64str,pfxpath, pfx_pwd);
		HeaderPost.put("content", data_content);
		
		String PostString = HttpUtil.RequestForm(ServerUrl, HeaderPost);		
		Log.Write("请求返回：" + PostString);
		
		PostString = RsaCodingUtil.decryptByPubCerFile(PostString, cerpath);
		String PostStrDe = SecurityUtil.Base64Decode(PostString);
		Log.Write("请求返回(明)：" + PostStrDe);
		
	}
}